(require 'dash)
(require 'cl-lib)

(defvar strings (all-completions "" obarray))

(length strings)
53669

;;; union

(benchmark 1 '(-union strings (reverse strings)))
"Elapsed time: 0.129663s (0.100519s in 2 GCs)"

(benchmark 1 '(let ((-compare-fn #'string=))
                (-union strings (reverse strings))))
"Elapsed time: 38.976084s"

(benchmark 1 '(seq-union strings (reverse strings)))
"Elapsed time: 143.587395s (0.140512s in 3 GCs)"

;; XXX: Explain why `reverse'.
(benchmark 1 '(cl-union strings (reverse strings)))
"Elapsed time: 1.336158s (0.040275s in 1 GCs)"

;;; nreverse

(benchmark 100 '(reverse strings))
"Elapsed time: 0.787493s (0.752268s in 20 GCs)"

(benchmark 100 '(setq strings (nreverse strings)))
"Elapsed time: 0.021352s"

;;; remove/delete

(benchmark 100 '(cl-remove "" (reverse strings)))
"Elapsed time: 2.106169s (1.604644s in 34 GCs)"

(benchmark 100 '(cl-delete "" (reverse strings)))
"Elapsed time: 1.225394s (0.814619s in 17 GCs)"

(benchmark 100 '(remove "" (reverse strings)))
"Elapsed time: 1.984759s (1.819520s in 34 GCs)"

(benchmark 100 '(delete "" (reverse strings)))
"Elapsed time: 0.961648s (0.865466s in 17 GCs)"

;;; filter

(benchmark 100 '(cl-remove-if #'string-empty-p (reverse strings)))
"Elapsed time: 2.501192s (1.732724s in 31 GCs)"

(benchmark 100 '(cl-delete-if #'string-empty-p (reverse strings)))
"Elapsed time: 1.358473s (0.777458s in 14 GCs)"

(benchmark 100 '(seq-filter #'string-empty-p (reverse strings)))
"Elapsed time: 2.187890s (1.576257s in 25 GCs)"

;; XXX: Note the macro-based approach
(benchmark 100 '(-filter #'string-empty-p (reverse strings)))
"Elapsed time: 1.198903s (0.783164s in 14 GCs)"

;;; unique

(benchmark 10 '(copy-sequence strings))
"Elapsed time: 0.151630s (0.140283s in 2 GCs)"

(benchmark 10 '(delete-dups (copy-sequence strings)))
"Elapsed time: 0.433367s (0.309530s in 5 GCs)"

(let ((ss (sort (copy-sequence strings) #'string<)))
  (benchmark 10 `(delete-consecutive-dups (copy-sequence ',ss))))
"Elapsed time: 0.156357s (0.118028s in 2 GCs)"

(benchmark 10 '(seq-uniq (copy-sequence strings)))
"Elapsed time: 1054.004204s (0.864523s in 13 GCs)"

(benchmark 10 '(-distinct (copy-sequence strings)))
"Elapsed time: 0.546400s (0.401054s in 8 GCs)"

(benchmark 10 '(cl-delete-duplicates (copy-sequence strings)))
;; too long to wait
